Download it now!
Bug 84645 - FILEOPEN: RTF column handling not working
Summary: FILEOPEN: RTF column handling not working
Status: VERIFIED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Writer (show other bugs)
Version:
(earliest affected)
4.1.3.2 release
Hardware: x86-64 (AMD64) All
: medium normal
Assignee: Miklos Vajna
URL:
Whiteboard: target:4.4.0 target:4.3.5
Keywords: bibisected, filter:rtf, regression
Depends on:
Blocks: RTF
  Show dependency treegraph
 
Reported: 2014-10-04 01:14 UTC by Tim Lloyd
Modified: 2015-12-17 11:06 UTC (History)
3 users (show)

See Also:
Crash report or crash signature:


Attachments
Original 2 column document (12.84 KB, application/vnd.oasis.opendocument.text)
2014-10-04 05:36 UTC, Joey Reid
Details
Exported with Writer 4.4 (46.41 KB, application/msword)
2014-10-04 05:37 UTC, Joey Reid
Details
Exported with Word 2013 (56.39 KB, application/msword)
2014-10-04 05:38 UTC, Joey Reid
Details
Comparison of original vs RTF roundtrip (154.97 KB, image/png)
2014-10-04 05:47 UTC, Joey Reid
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Tim Lloyd 2014-10-04 01:14:17 UTC
between 4.2 and 4.3 the following functionality changed:

 * open a new writer document
 * format page to include 2 columns
 * populate the columns
 * save as .odt
 * Close and reopen - all good
 * Save the doc as .rtf
 * Close and reopen - not so good. The 2 columns are maintained but the
   contents are in different places. 

Tested on Fedora linux. 

I have left the severity at "normal". Obviously those using rtf may see this differently
Comment 1 Joey Reid 2014-10-04 05:36:23 UTC
Created attachment 107302 [details]
Original 2 column document

Confirmed on Version: 4.4.0.0.alpha0+
TinderBox: Win-x86@39, Branch:master, Time: 2014-10-03_00:31:27

This is a RTF import issue. The exported RTF opens perfectly in Word. And when Word exports the ODT file to RTF, Writer has the same issues opening Word's RTF export as its own.
Comment 2 Joey Reid 2014-10-04 05:37:26 UTC
Created attachment 107303 [details]
Exported with Writer 4.4
Comment 3 Joey Reid 2014-10-04 05:38:08 UTC
Created attachment 107304 [details]
Exported with Word 2013
Comment 4 Joey Reid 2014-10-04 05:47:03 UTC
Created attachment 107307 [details]
Comparison of original vs RTF roundtrip

Added Miklos as he's been active on RTF
Comment 5 Terrence Enger 2014-10-05 18:49:39 UTC
Using the 43all bibisect repository, I see from `git bisect good`:

    f404200bd6f153825680cab6261f756ef7b77770 is the first bad commit
    commit f404200bd6f153825680cab6261f756ef7b77770
    Author: Bjoern Michaelsen <bjoern.michaelsen@canonical.com>
    Date:   Fri Oct 18 08:16:51 2013 +0000

        source-hash-b73dec8a06ef762098e642b2c37e4baad780b11a
    
        commit b73dec8a06ef762098e642b2c37e4baad780b11a
        Author:     Caolán McNamara <caolanm@redhat.com>
        AuthorDate: Thu Sep 12 10:56:37 2013 +0100
        Commit:     Caolán McNamara <caolanm@redhat.com>
        CommitDate: Thu Sep 12 10:56:37 2013 +0100
    
            Resolves: rhbz#1006850 crash in SwCommentRuler::GetCommentControlRegion
    
            Change-Id: Ic846da3b22391d724da6f8df94dd771e89d2efb4

    :100644 100644 75ae8cb6d26ff1b192635a72ca6efdf5f6e4784f 9e037130f89a614dcbc1306794264e788fc522fc M	ccache.log
    :100644 100644 b9f68f0cca442a62cf2e7d78c0ef00301b4f8998 ad579d3218691e77125b0b637f9eeb0bc2912b0d M	commitmsg
    :100644 100644 d659d1ed51d313071b842cb464ec1d3fe1d279ed 909f5b641df89c36e11e2e3470a358ac102a2dc9 M	dev-install.log
    :100644 100644 227d63f870d43971bbca014706c81ad09c6e8a38 7616230c95235af7a3dc9c936e0061c12fd0253c M	make.log
    :040000 040000 8560cf1b3ea44e9dee911e65e2a214874536dc04 2d485b61bde964843cc5640771d37d37b450f5fd M	opt

and from `git bisect log`:

    # bad: [423a84c4f7068853974887d98442bc2a2d0cc91b] source-hash-c15927f20d4727c3b8de68497b6949e72f9e6e9e
    # good: [65fd30f5cb4cdd37995a33420ed8273c0a29bf00] source-hash-d6cde02dbce8c28c6af836e2dc1120f8a6ef9932
    git bisect start 'latest' 'oldest'
    # good: [e02439a3d6297a1f5334fa558ddec5ef4212c574] source-hash-6b8393474974d2af7a2cb3c47b3d5c081b550bdb
    git bisect good e02439a3d6297a1f5334fa558ddec5ef4212c574
    # bad: [4850941efe43ae800be5c76e1102ab80ac2c085d] source-hash-980a6e552502f02f12c15bfb1c9f8e6269499f4b
    git bisect bad 4850941efe43ae800be5c76e1102ab80ac2c085d
    # skip: [a043626b542eb8314218d7439534dce2fc325304] source-hash-9379a922c07df3cdb7d567cc88dfaaa39ead3681
    git bisect skip a043626b542eb8314218d7439534dce2fc325304
    # skip: [aba65c3e4c0df07e4909aeefb758cdb688242bf6] source-hash-827524abfb4b577d08276fde40929a9adfb7ff1a
    git bisect skip aba65c3e4c0df07e4909aeefb758cdb688242bf6
    # skip: [aba65c3e4c0df07e4909aeefb758cdb688242bf6] source-hash-827524abfb4b577d08276fde40929a9adfb7ff1a
    git bisect skip aba65c3e4c0df07e4909aeefb758cdb688242bf6
    # bad: [c81a8a0dcfc1ed095a80e4485c89dd0fcaf73f31] source-hash-c69ed33628ec0b7abf6296539cf280d6c4265930
    git bisect bad c81a8a0dcfc1ed095a80e4485c89dd0fcaf73f31
    # good: [1d4980621741d3050a5fe61b247c157d769988f2] source-hash-89d01a7d8028ddb765e02c116d202a2435894217
    git bisect good 1d4980621741d3050a5fe61b247c157d769988f2
    # skip: [89110ca258fa7a15dfc546acfb39e76fc3eb2a44] source-hash-e450a2c506ac7cd4433b0f93fc750a89919bc03c
    git bisect skip 89110ca258fa7a15dfc546acfb39e76fc3eb2a44
    # good: [1cca92a409385d9288c28a54d5e3008e56728bc0] source-hash-7be7824bbbdeee6fa998b950e6046ab37fe690cb
    git bisect good 1cca92a409385d9288c28a54d5e3008e56728bc0
    # skip: [5fa28ce2931a35ae64ae08d3904cfb76d24459d8] source-hash-2304beaca33c63b94df99cb827716f00ce259f9a
    git bisect skip 5fa28ce2931a35ae64ae08d3904cfb76d24459d8
    # bad: [2a9ff869c5638dc5c3aa387d0fe55c3291c86288] source-hash-01b7e04172889cbc9e4ac404b105e18ddc062d6f
    git bisect bad 2a9ff869c5638dc5c3aa387d0fe55c3291c86288
    # bad: [9771d0c212cfa71b07742ff3dc5c05df22d600eb] source-hash-a9a0933ec67eab0ec31c8fadb60fb8e8e3e90485
    git bisect bad 9771d0c212cfa71b07742ff3dc5c05df22d600eb
    # bad: [b68886f4c56ebc4cdf94aee9753398ccce28bb41] source-hash-90830788b1f8fd61ea86135712868aeda395edd0
    git bisect bad b68886f4c56ebc4cdf94aee9753398ccce28bb41
    # bad: [56d7a7963ef4d32b0c5b60dc5f85d4bc218785d9] source-hash-1a412370ab03af8f3865ccbfaaa8dcff1d0ac0ad
    git bisect bad 56d7a7963ef4d32b0c5b60dc5f85d4bc218785d9
    # good: [e014985ca41d06649533c7bedb4f029cbcb4ed6e] source-hash-af40ffdcef60c65437df4749c8bb2ad24356d1c2
    git bisect good e014985ca41d06649533c7bedb4f029cbcb4ed6e
    # bad: [f404200bd6f153825680cab6261f756ef7b77770] source-hash-b73dec8a06ef762098e642b2c37e4baad780b11a
    git bisect bad f404200bd6f153825680cab6261f756ef7b77770
    # good: [f6d96278d80e0a22881e1f476dd4d8bfb3f35814] source-hash-f0b57c30fdb5ecdd25879844159b9038399bc6de
    git bisect good f6d96278d80e0a22881e1f476dd4d8bfb3f35814
    # first bad commit: [f404200bd6f153825680cab6261f756ef7b77770] source-hash-b73dec8a06ef762098e642b2c37e4baad780b11a
Comment 6 Joey Reid 2014-10-06 07:42:01 UTC
@Miklos
Could this be similar to Bug 81345 related to 
http://cgit.freedesktop.org/libreoffice/core/commit/?id=4e653d15eff26aa5283d8ba20611893f4c573f57
DOCX import: fix default section break type inside multiple columns

Where you changed the dmapper PropertyMap?
Comment 7 Miklos Vajna 2014-11-08 21:43:46 UTC
No, this change is much newer. Bibisect says it's the ecbc20d0c7d58c3c6cd0e1c517848157107120a0..efea971d33d83b39bcb883da51cc204a981897f9 range, most probably 82e17dbb2a16c7653a163139f0eea51faa4d46b8, i.e. Michael's fix for bug 77996.

However, that just made the already existing problem visible. The real problem is that the section is balanced, but it's not balanced in Word.
Comment 8 Commit Notification 2014-11-08 22:09:02 UTC
Miklos Vajna committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=f4bb73164a51ec83fe1d5975b1232d35f8a9e88a

fdo#84645 RTF import: set DontBalanceTextColumns=true for the last section ...

It will be available in 4.4.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 9 Miklos Vajna 2014-11-15 18:22:44 UTC
4-3 review: https://gerrit.libreoffice.org/12462
Comment 10 Marina Latini (SUSE) 2015-01-15 14:29:11 UTC
Verified on:

* Version: 4.5.0.0.alpha0+
* Build ID: 84c69550bcb8139669de9cf98b51c35f21fe853d
* TinderBox: Linux-rpm_deb-x86_64@46-TDF, Branch:master, Time: 2015-01-13_08:44:23
* Locale: it_IT

on Ubuntu 14.04.1 LTS x86_64 with fresh user profile
Comment 11 Robinson Tryon (qubit) 2015-12-17 11:06:46 UTC Comment hidden (obsolete)